JD Edwards Anypoint&trade; Studio Connector Demo (Submit UBE)
==================================================================

## Introduction

The current demo application provides a simple workflow to:

* Submit an UBE (R0008P - Date Pattern Report)
* Check UBE Status

## Prerequisites

* Java 7
* Anypoint Studio 5.4.x
* Mule Runtime 3.7.0 EE or higher
* DataWeave
* JDE Connector User manual has been read
* JDE bundle must be created. (See [User Manual Site](http://modusintegration.github.io/mule-connector-jde/1.1.0/functional/user-manual.html): _Generate Bundle_)
* JDE standards ini files (See [User Manual Site](http://modusintegration.github.io/mule-connector-jde/1.1.0/functional/user-manual.html): _Copy JDE ini Files to the Projet_)
* JDE Enterprise Server is reachable from your location

## Import the project

* Go to **File > Import**
* Select **Anypoint Studio Project from External Location** (under the parent folder "Anypoint Studio")

![Menu](images/jde_connection_config01.png)

* Provide the root path to the demo project folder.
* Select Mule Runtime (3.7.x EE).

![File Selection](images/jde_connection_config02.png)

* Click **Finish**.  
* Set Cookbook credentials inside the file `src/main/app/mule-app.properties`.

```
jde.user=<JDE_USER>
jde.password=<JDE_PASSWORD>
jde.environment=<JDE_ENVIRONMENT>
jde.role=<JDE_ROLE>
jde.imagefoldercache=<LOCAL_FOLDER>
```

* Copy **JDE ini Files** inside the Project.

Put the files inside the project folder in the folder:

* source/main/resource
* root folder of the project

![Test Connection](images/jde_connection_config06.png)


* Inside the Global Elements view, double-click the **JDE Configuration** component.

![Test Connection](images/jde_connection_config03.png)

Add JDE Bundle jar file.

![Test Connection](images/jde_connection_config04.png)

Click "Test Connection".

![Test Connection](images/jde_connection_config05.png)

* A successful message should pop-up.

![Test Connection](images/jde_connection_config07.png)

* Save the project and from the Project Folder, Select **Run as Mule Application**

* Open a browser and access the URL `http://localhost:8081`. You should see the demo application deployed:

![Workflow Demo](images/jde_connection_run01.png)

## About the flows

**1. Html_Form_Flow:** renders the HTML form with a `parseTemplate` component.

![Flow HMTL Form](images/jde_connection_flow01.png)

**2. JDE_submitUBEFlow:** Submit UBE **R0008P XJDE0001** and It starts flow to check UBE Status (See below)

![Flow Get](images/jde_connection_flow02.png)

**3. jde_getJobStatusFlow:** retrieves UBE Status from the UBE submited.

![Flow Get](images/jde_connection_flow03.png)

**4. Choice_Exception_Strategy:** global exception strategy that handles every exception that may arise at runtime and forwards it to the HTML form for better troubleshooting in the front-end side.

![Flow 6 Exception](images/jde_connection_flow04.png)

## Run the demo

### Submit UBE
* Click the link **"Query"**.
* Enter the Fiscal Date Pattern and Enter Begin Date.

![Flow Get](images/jde_connection_run02.png)

* Click the **"Submit Date Pattern Report"** button and wait for job id generated.

![Flow Get](images/jde_connection_run05.png)

* Check log to see when the Job ending:

```
[[demo_submit_ube].HTTP_Listener_Configuration.worker.01] org.mule.api.processor.LoggerMessageProcessor: Submiting R0008P ....
[[demo_submit_ube].HTTP_Listener_Configuration.worker.01] org.mule.lifecycle.AbstractLifecycleManager: Initialising: 'VM.dispatcher.594317562'. Object is: VMMessageDispatcher
[[demo_submit_ube].HTTP_Listener_Configuration.worker.01] org.mule.lifecycle.AbstractLifecycleManager: Starting: 'VM.dispatcher.594317562'. Object is: VMMessageDispatcher
[[demo_submit_ube].jde_getJobStatusFlow.stage1.02] org.mule.api.processor.LoggerMessageProcessor: Current Job Status: S
[[demo_submit_ube].jde_getJobStatusFlow.stage1.02] org.mule.api.processor.LoggerMessageProcessor: Current Job Status: D
[[demo_submit_ube].jde_getJobStatusFlow.stage1.02] org.mule.api.processor.LoggerMessageProcessor: Jobs Ends Correctly
```

* Check Job from JD Edwards EnterpriseOne

Work Submit Job application:

![Flow Get](images/jde_connection_jde01.png)

Report Interconnect:

![Flow Get](images/jde_connection_jde02.png)

Data Selection:

![Flow Get](images/jde_connection_jde03.png)

PDF:

![Flow Get](images/jde_connection_jde04.png)

* **Congratulations!** You have successfully run this demo. Continue exploring the connector by playing with other available [demos](http://modusintegration.github.io/mule-connector-jde/) or visiting the [JD Edwards Connector Documentation Site](http://modusintegration.github.io/mule-connector-jde/1.1.0/functional/user-manual.html) and  the [DevKit Cookbook Tutorial](http://mulesoft.github.io/mule-cookbook-tutorial).
